// Code generated by "enumer -type=RepoTypes -json -text -yaml -sql"; DO NOT EDIT.

//
package repositoryTypes

import (
	"database/sql/driver"
	"encoding/json"
	"fmt"
)

const _RepoTypesName = "UnknownAssetBtxCatalogConfigLtxMediaTemplateWebSite"

var _RepoTypesIndex = [...]uint8{0, 7, 12, 15, 22, 28, 31, 36, 44, 51}

func (i RepoTypes) String() string {
	if i < 0 || i >= RepoTypes(len(_RepoTypesIndex)-1) {
		return fmt.Sprintf("RepoTypes(%d)", i)
	}
	return _RepoTypesName[_RepoTypesIndex[i]:_RepoTypesIndex[i+1]]
}

var _RepoTypesValues = []RepoTypes{0, 1, 2, 3, 4, 5, 6, 7, 8}

var _RepoTypesNameToValueMap = map[string]RepoTypes{
	_RepoTypesName[0:7]:   0,
	_RepoTypesName[7:12]:  1,
	_RepoTypesName[12:15]: 2,
	_RepoTypesName[15:22]: 3,
	_RepoTypesName[22:28]: 4,
	_RepoTypesName[28:31]: 5,
	_RepoTypesName[31:36]: 6,
	_RepoTypesName[36:44]: 7,
	_RepoTypesName[44:51]: 8,
}

// RepoTypesString retrieves an enum value from the enum constants string name.
// Throws an error if the param is not part of the enum.
func RepoTypesString(s string) (RepoTypes, error) {
	if val, ok := _RepoTypesNameToValueMap[s]; ok {
		return val, nil
	}
	return 0, fmt.Errorf("%s does not belong to RepoTypes values", s)
}

// RepoTypesValues returns all values of the enum
func RepoTypesValues() []RepoTypes {
	return _RepoTypesValues
}

// IsARepoTypes returns "true" if the value is listed in the enum definition. "false" otherwise
func (i RepoTypes) IsARepoTypes() bool {
	for _, v := range _RepoTypesValues {
		if i == v {
			return true
		}
	}
	return false
}

// MarshalJSON implements the json.Marshaler interface for RepoTypes
func (i RepoTypes) MarshalJSON() ([]byte, error) {
	return json.Marshal(i.String())
}

// UnmarshalJSON implements the json.Unmarshaler interface for RepoTypes
func (i *RepoTypes) UnmarshalJSON(data []byte) error {
	var s string
	if err := json.Unmarshal(data, &s); err != nil {
		return fmt.Errorf("RepoTypes should be a string, got %s", data)
	}

	var err error
	*i, err = RepoTypesString(s)
	return err
}

// MarshalText implements the encoding.TextMarshaler interface for RepoTypes
func (i RepoTypes) MarshalText() ([]byte, error) {
	return []byte(i.String()), nil
}

// UnmarshalText implements the encoding.TextUnmarshaler interface for RepoTypes
func (i *RepoTypes) UnmarshalText(text []byte) error {
	var err error
	*i, err = RepoTypesString(string(text))
	return err
}

// MarshalYAML implements a YAML Marshaler for RepoTypes
func (i RepoTypes) MarshalYAML() (interface{}, error) {
	return i.String(), nil
}

// UnmarshalYAML implements a YAML Unmarshaler for RepoTypes
func (i *RepoTypes) UnmarshalYAML(unmarshal func(interface{}) error) error {
	var s string
	if err := unmarshal(&s); err != nil {
		return err
	}

	var err error
	*i, err = RepoTypesString(s)
	return err
}

func (i RepoTypes) Value() (driver.Value, error) {
	return i.String(), nil
}

func (i *RepoTypes) Scan(value interface{}) error {
	if value == nil {
		return nil
	}

	str, ok := value.(string)
	if !ok {
		bytes, ok := value.([]byte)
		if !ok {
			return fmt.Errorf("value is not a byte slice")
		}

		str = string(bytes[:])
	}

	val, err := RepoTypesString(str)
	if err != nil {
		return err
	}

	*i = val
	return nil
}
